Index: Tst/Short/normal.res.gz.uu
===================================================================
--- Tst/Short/normal.res.gz.uu	(revision 09f4209c70decf260ced8dd894cf48293570bc16)
+++ Tst/Short/normal.res.gz.uu	(revision 0750dc3a640b73f5e765a62b01fc8353be4502d4)
@@ -1,46 +1,46 @@
 begin 644 normal.res.gz
-M'XL(".^;73H``VYO<FUA;"YR97,`[1K9;MLX\-U?010+U+)$U^(AVS7BA^V^
-M++#8AS9OB\U"5QHUB6U(<GQ\_0Y)\?+1I&G:W0+U`R4-Y^9P.,/DP^5OO_^)
-M$(KGZ(_??T6OVJ8=WE79JUGO0S=#Y@B`_U2+JNT'LYYXHOD<+9;U?7HW7)2;
-M8=.FK4&G<V3>V5`P?=6A^FRY@Y<,45TM/J+Z@L;3:1SUTRB+\JB(RB`J5I9F
-M/$=54:9WJ+HPL,D0\33+BQ*G'&<<YQP7')<\,AC3(4HSFH=93HLPI5D9Y@4M
-MP[0HJ4&*1X!$LIR$&<D+$J:D(("2D9*$.2E*8C%CP0ZD9`PF,`$JH`!<X$Y`
-M"0;((`K>*=`[>L1$$)*<@99Y@8&.`AD!7DI6P4HBH'E),3!T""D04B$%"UPF
-MU,II"6S`Z"(I0YI*>9*Z9+@H$TL+2Y`RP,=2#H4'!THJ;,)IP84"1'@/S`06
-MS!+R(<H2X;0$G)&Q$E,A%LC"G$E#J:`"?N!+87#)S3K%B5W;>#Q$=U73HE5]
-MH>*@7T$4]=Z\0:_5]VN4UV7:E@5*%>;R&L4R'OI-,$0"\W*)FK)$[4TIX4V$
-MVMVJ1/WJ6L(6Z7TIJ';+=:U85(V(S^!M#XE?<[/<]"5@AHY^'?\TS\NFD>QB
-M#!QD/*:+`MVG*]1OJOOJ+JUJ=+VL)<X2AKH)E"*=F**\1N_1A1#T5_SW#%1N
-M)9?W(!5@53%3FV8UDT+?OY%`H:LO==E9);U3[=.V6BZ$*H)(,9#SXGE=+^^5
-M/G7UL5K`SLC2II1<VJ668)9B,H=5F/5`.:DQL$,HOTGK-&^!IFFK'+U%<@?V
-MY-QB?9^5M=#G(:T;F!LKN/QE=\O\5B0.@"_K0@E-'03[>RM7J!&OE_TX@(&(
-M@8J!B8&+(1'#.$!G6&S*ZN--*YF`S#,#5\,)-8FK9K%Z63VU$.H*>6?\/IW+
-MV*CCBY6,##U!1G,3)'5LP?'\(%YZ\A-(+X1>5V0@-!L(S:Y(*-XEB`H04Z`.
-MBZD'#R1H8%"YPJ(:JP-U<HB2H]"IY!Q:B512*!E4:R(E:`6H)U)SIQUWVEG!
-ME>9<Z2$>0,HQ'QC9UB;-$-CPC@T3;%R<*X8E)V8I<,<J"3HB[E@V<.R_(M@Q
-M]L!G3/'LV+G>MYXD!_Z6#%WEKYAVH5$F41:X0EF`G77L_*:M&&O"L1<'[MJ[
-MP>`N@^<4WP!?9>L;KAWJJCQQG`YK109^6!VLE@F63@(V,<,\UZEWCKMW8^?T
-M:+686B9F9>%#3UCQ\<$2:[CUD&,X.78Z]TR/1^ZNT"X.3P2K9ZUQ=L=46Z[B
-MW;4VCKMXX'K'6<.H%\Y^['I39O=U^]L3T.WK;M=V-N"CO4"Q44,R9OH]=-;[
-M8+6E#[DO3F]T9@FL!7I+>3%\M(!'464CQK>4^6O5)0<W4/0N5#;HP*0:S`9G
-M`@GBD@W.!!.LHEE?"QR?"HJ!B:?3D3E6"^%'IH([JIF48RG\+2SAH1#C+04_
-M/#E,3H,0COETZF1=?\^":_3\89CH)"'F57[IXD0&]YDX20SZX:GE.8=X)B7!
-MB<-*PE7*Y\KL`T7`01IR=CFD$[GA(`9S#,:)MU]<"VTF.\QQ^B0AGI/9T?GI
-M.NHHZI)3:4K9>R+>C">23G<H&72MH#^)VA#Z4VY-:C[E=F'F4T8+#TP]`AW@
-M;75WA^K(K5*<1H\PV\"1T8A&_6VTB_9!M%GU242C)+!DW/9P^QW!^RW%V\1.
-M0^MPHEV`4FLP0'4)913TGR!H50/@9Q?Q'W019/RD+D*$P9DN@GV3+N();0-!
-MLD:'7R*&\3?J$Y[<&)#)N<9@>K(QH*-'&@.5J&RNL16L7]D?YAWWK+7GZT&]
-MSCR6;OW@'RSN^::JAR],2MK:^%3:H<2F'4K/I!WGSH@RFV_Z6[P+!C#N8=S!
-M:+&<VRB:G+RQ>%X*HC]3T,NG(/K5*8@\EH*^9.<_ED7>]2#2?Q!%Z0^BJ(Z$
-M<QF4ZCL7(B:(G6"G[US89^Y<1E[Z(G[ZBOWT14SZ8B>K)N943>RH:LJB)FJC
-M=?00;:+C5,:<),4@2:FT=FNNPMEXB#8[_+`WE[AL,D0/6[S>6<ATB-H'W&P,
-MA(^&J%GC[,%"8L!9[P"T-[(YT6GTT\66[$BX)7L2[F"P*-1FVONF+?K5`F*G
-M*?.V_RFZ#0)W%3A[P3*/_<RQ+Y]C.?_:'!O'W^.V^+(_$<-4#/%(CO&3BD%U
-M8?SL\;M<,3]JW)GZ\OGG3?*2:?R47=_R#/H_*,^>J_STZY7/$&0'M$8/:(.V
-M:(?V3S](>7+F(.7C;H*)">9,3$X>I'SZN1YEVMTRCT2#$,=>6S(1L*FZ@QE(
-M'+<!&9O9B4_+%*UJ8D;FZ>%PPV$B^I5IQ]^\QMZ5_/B`22C'E[U:Z3ZEO,1\
-MCI5X_3E1ING/J?*@]G3B5C+,+$#RF4I&5@?6Y^T.-WOKY`U4"GOK55DX6`>V
-M6YSMK9L:^-2SH+:L*>P?"5HH*/0GJ"WK"\=]F>.[QG%<ZWAM[;CLP?'7QG'6
-LUO'4SG'3WCC#Z183Z!:/"[*$.1A\*/_50?P_P[J!)9[]TOL7D8-R9B`A````
+M'XL("/3?E#H``VYO<FUA;"YR97,`[1K9;MLX\#U?010+U+)$U^(AVS7BA^V^
+M%%CL0YNWQ6:A*XV:Q#8D.3Z^?H>D>/EHTAS%%J@?*&DX-X?#&<*?+_[X^!="
+M*)ZA/S_^CMZT33NXK;(WT[//W0R9(0#^6\VKMA=,S\03S69HOJCOTMO!O%P/
+MFC9M#3J=(?/.!H+IFP[59\L=O&2`ZFK^!=7G-)Y,XJB71EF41T54!E&QM#2C
+M&:J*,KU%U;F!C0>(IUE>E#CE..,XY[C@N.21P9@,4)K1/,QR6H0IS<HP+V@9
+MID5)#5(\!"22Y23,2%Z0,"4%`92,E"3,25$2BQD+=B`E8S"!"5`!!>`"=P)*
+M,$`&4?!.@=[1(R:"D.0,M,P+#'04R`CP4K(*5A(!S4N*@:%#2(&0"BE8X#*A
+M5DY+8`-&%TD9TE3*D]0EPT696%I8@I0!/I9R*#PX4%)A$TX++A0@PGM@)K!@
+MEI`/4)8(IR7@C(R5F`JQ0!;F3!I*!17P`U\*@TMNUBE.[-K&HP&ZK9H6+>MS
+M%0>]"J+H[-T[]%9]OT5Y7:9M6:!482ZN4"SCH=<$`X%XL4!-6:+VNI3@)D+M
+M=EFB7G4E8?/TKA1$V\6J5ARJ1H1G\/X,B5]SO5CW)&#:<4OSO&P:21QCP)?!
+ME\X+=)<N4:^I[JK;M$97BUJB+&"HFT!)[7@6Y17ZA,X%U[_C?Z:@7RN9?)HB
+M`:N*J=H@2RGRTSL)$WKY,A>=!=(1U2YMJ\5<*"*(%+V<%\^K>G&GU*FK+]4<
+M-D&6-J7DTBZT!./U\0P</CT#W:3"P`ZA_#JMT[P%FJ:M<O0>R<UV)N?FJ[NL
+MK(4^]VG=P-Q(P>4ONUWD-R)'`'Q1%TIHZB#8WWNY&HUXO>C%`0Q$#%0,3`Q<
+M#(D81@$ZP6)=5E^N6\D$9)X8N!J.J$E<-8OER^JIA5!7R`?C]\E,AD8=GR]E
+M8.@),IR9&*EC"XYG^^$B/X'T7.AU2?I"L[[0[)*$XEV"J``Q!>JPF'KP0(+Z
+M!I4K+*JQ.E`GAR@Y"IU*SJ&52"6%DD&U)E*"5H!Z(C5WVG&GG15<:<Z5'N(!
+MI!SSOI%M;=(,@0WOV##!QL6Y9%AR8I8"=ZR2H"/BCF5]Q_Y+@AUC]WS&%,^.
+MG>M]ZTFRYV_)T%7^DFD7&F4298$KE`786<?.;]J*D28<>7'@KKT;#.XR>$[Q
+M#?!5MK[AVJ&NRF/'Z;!6I.^'U=YJF6#I)&`3,\QSG7KGN'LW=DX.5HNI96)6
+M%M[WA!4?[RVQAEL/.8:30Z=SS_1XZ.X*[>+P2+!ZUAIG=TRUY2K>76OCN(L'
+MKG><-8QZX>S'KC=E=E^WOST!W;[N=FUG`S[8"Q0;-21CIM]#9[WW5EOZD/OB
+M]$9GEL!:H+>4%\,'"W@0539B?$N9OU9=<G`#1>]"98,.3*K!K'\BD"`N6?]$
+M,,$JFO6UP-&QH.B;>#H>F2.U$'YD*KBCFDDYEL+?PA(>"C'>4O#]D\/D-`CA
+MF$\F3M;U]RRX1L_OAXE.$F)>Y9<N3F1PGXB3Q*#OGUJ><XAG4A(<.:PD7*5\
+MKLS>4P0<I"$GET,ZD1L.8C#'8)QX^\6UT&:R_1RG3Q+B.9D=G)^NHPZB+CF6
+MII2]1^+->"+I=(>20=<*^I.H#:$_Y=:DYE-N%V8^9;3PP-0CT.S=5+>WJ([<
+M*L7IZ0BSO1H9#FG4VT3;:!=$ZV6/1#1*`DO&;;NVVQ*\VU"\2>PT=`E'.@,H
+MM?I]5)=01D&K"8*6-0!^-0ROVS"0T:,:!K'B)QH&]BH-PR,Z!()D.0Z_1`RC
+M5VH)'MT#D/&I'F!RM`>@PP=Z`)63;%JQQ:I?Q.^G&/=8M4?I7FG./)9NJ>"?
+M(>Y1I@J%[\P_VMKX6(:AQ&882D]D&.<FB#*;6GH;O`WZ,.Y@W,)HL9P[)IH<
+MO8=X6K:AO[+-L[(-?7:V(0]EF^_9Y`\EC`]G$-0_B:+T)U%41\*I9$GU30H1
+M$\1.L.,W*>P;-RE#+U,1/U/%?J8B)E.QH[40<VHA=E`+95$3M=$JNH_6T6'6
+M8DX^8I"/5`:[,7?9;#1`ZRV^WYE;6#8>H/L-7FTM9#)`[3UNU@;"AP/4K'!V
+M;R$QX*RV`-H9V9SHC/GU?$.V)-R0'0FW,%@4:I/J7=,6O6H.L=.4>=O[&MT$
+M@;L*G+U@\<9^I=-GI5/.GYM.X_A'7/=>],9BF(@A'LHQ?E2)IVY\GSS^D#OB
+M!XT[434^_6A)7C)C'[/K-8^;_X/R[*G*3YZO?(8@.Z`5ND=KM$%;M'O\F<F3
+M$V<F'W433$PP9V)\],SDDV]U'I/NFG@HROXX]IJ-L8!-U"5*7^*X;<7(S(Y]
+M6J9H56LR-$\/AQL.8]&%3#K^YC7V[M1'>TQ".;[LW4CW*>4EYG.DQ.O/L3)-
+M?TZ4![6G$[=H868!DF\4+;(0L#YOM[C962>OH2C86:_*&L$ZL-W@;&?=U,"G
+MG@6U9?E@;_E;J!WT)Z@M2PG'?9GCN\9Q7.MX;>6X[-[QU]IQUL;QU-9QT\XX
+DP^D!$^@!#VNOA#D8?"#_EB#^>[!J8(FGOYW]!POJ,B/,(```
 `
 end