Index: Singular/iparith.cc
===================================================================
--- Singular/iparith.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ Singular/iparith.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -3038,5 +3038,5 @@
 
   maxl--;
-  if ((maxl==-1) /*&& (iiOp!=MRES_CMD)*/)
+  if (/*(*/ maxl==-1 /*)*/) /*&& (iiOp!=MRES_CMD)*/ 
   {
     maxl = currRing->N-1+2*(iiOp==MRES_CMD);
@@ -3153,5 +3153,5 @@
 
   maxl--;
-  if ((maxl==-1) /*&& (iiOp!=MRES_CMD)*/)
+  if (/*(*/ maxl==-1 /*)*/) /*&& (iiOp!=MRES_CMD)*/ 
   {
     maxl = currRing->N-1+2*(iiOp==MRES_CMD);
Index: Singular/ipassign.cc
===================================================================
--- Singular/ipassign.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ Singular/ipassign.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -502,5 +502,5 @@
 static BOOLEAN jiA_1x1INTMAT(leftv res, leftv a,Subexpr e)
 {
-  if ((res->rtyp!=INTMAT_CMD) /*|| (e!=NULL) - TRUE because of type int */)
+  if (/*(*/ res->rtyp!=INTMAT_CMD /*)*/) /*|| (e!=NULL) - TRUE because of type int */ 
   {
     // no error message: assignment simply fails
@@ -524,5 +524,5 @@
 static BOOLEAN jiA_1x1MATRIX(leftv res, leftv a,Subexpr e)
 {
-  if ((res->rtyp!=MATRIX_CMD) /*|| (e!=NULL) - TRUE because of type poly */)
+  if (/*(*/ res->rtyp!=MATRIX_CMD /*)*/) /*|| (e!=NULL) - TRUE because of type poly */ 
   {
     // no error message: assignment simply fails
@@ -846,5 +846,5 @@
 
   int lt=l->Typ();
-  if((lt==0)/*&&(l->name!=NULL)*/)
+  if (/*(*/ lt==0 /*)*/) /*&&(l->name!=NULL)*/ 
   {
     if (!errorreported) Werror("left side `%s` is undefined",l->Fullname());
Index: Singular/maps_ip.cc
===================================================================
--- Singular/maps_ip.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ Singular/maps_ip.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -117,5 +117,5 @@
         res->data=(void *)prCopyR( (poly)data, preimage_r, currRing);
       else
-      if ((what==IMAP_CMD) || ((what==FETCH_CMD) /* && (nMap!=nCopy)*/))
+	if ( (what==IMAP_CMD) || /*(*/ (what==FETCH_CMD) /*)*/) /* && (nMap!=nCopy)*/
         res->data=(void *)p_PermPoly((poly)data,perm,preimage_r,currRing, nMap,par_perm,P);
       else /*if (what==MAP_CMD)*/
@@ -155,5 +155,5 @@
       }
       else
-      if ((what==IMAP_CMD) || ((what==FETCH_CMD) /* && (nMap!=nCopy)*/))
+	if ( (what==IMAP_CMD) || /*(*/ (what==FETCH_CMD) /*)*/) /* && (nMap!=nCopy)*/
       {
         for (i=R*C-1;i>=0;i--)
Index: dyn_modules/callgfanlib/gfan.cc
===================================================================
--- dyn_modules/callgfanlib/gfan.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ dyn_modules/callgfanlib/gfan.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -1688,5 +1688,5 @@
         ring tmpRing;
 
-        if( (srcRing->order[0]!=ringorder_a))
+        if(  /*(*/ srcRing->order[0]!=ringorder_a /*)*/ )
         {
                 int64vec *iv;// = new int64vec(this->numVars);
Index: dyn_modules/syzextra/mod_main.cc
===================================================================
--- dyn_modules/syzextra/mod_main.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ dyn_modules/syzextra/mod_main.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -701,5 +701,5 @@
   const int pos = rGetISPos(p, r);
 
-  if( (-1 == pos) )
+  if(  /*(*/ -1 == pos /*)*/  )
   {
     WerrorS("`GetInducedData([int])` called on incompatible ring (not created by 'MakeInducedSchreyerOrdering'!)");
@@ -777,5 +777,5 @@
   const int posIS = rGetISPos(p, r);
 
-  if( (-1 == posIS) )
+  if(  /*(*/ -1 == posIS /*)*/  )
   {
     WerrorS("`SetInducedReferrence(<ideal/module>, [int[, int]])` called on incompatible ring (not created by 'MakeInducedSchreyerOrdering'!)");
Index: factory/libfac/factor/Factor.cc
===================================================================
--- factory/libfac/factor/Factor.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ factory/libfac/factor/Factor.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -845,5 +845,5 @@
   // search an "optimal" main variavble
   int mv=F.level();
-  if ((mv != LEVELBASE) /* && (! F.isUnivariate()) */)
+  if (/*(*/ mv != LEVELBASE /*)*/) /* && (! F.isUnivariate()) */ 
   {
      mv=find_mvar(F);
Index: factory/libfac/factor/SqrFree.cc
===================================================================
--- factory/libfac/factor/SqrFree.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ factory/libfac/factor/SqrFree.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -219,5 +219,5 @@
   for (int k=1; k<=n; k++)
   {
-    if ((mipo.isZero())/*||(k!=1)*/)
+    if (/*(*/ mipo.isZero() /*)*/) /*||(k!=1)*/ 
     {
       g = swapvar(f,k,n); g = content(g);
@@ -266,5 +266,5 @@
     for (int k=1; k<=n; k++)
     {
-      if ((mipo.isZero())/*||(k!=1)*/)
+      if (/*(*/ mipo.isZero() /*)*/) /*||(k!=1)*/ 
       {
         g=swapvar(f,k,n) ;
Index: kernel/fast_maps.cc
===================================================================
--- kernel/fast_maps.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ kernel/fast_maps.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -469,5 +469,5 @@
         return NULL;
       }
-      if ((p==NULL) /* && (e>0)*/)
+      if (/*(*/ p==NULL /*)*/) /* && (e>0)*/ 
       {
         p=p_Copy(pp /*dest_id[i-1]*/,dest_r);
@@ -715,5 +715,5 @@
   {
     choice=iter->next;
-    if ((iter->f1==NULL))
+    if ( /*(*/ iter->f1==NULL /*)*/ )
     {
       ggT=maFindBestggT(iter, choice, fp, fq,src_r);
Index: kernel/ideals.cc
===================================================================
--- kernel/ideals.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ kernel/ideals.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -1219,5 +1219,5 @@
   intvec * weights;
   hom = (tHomog)idHomModule(h1,currQuotient,&weights);
-  if (/**addOnlyOne &&*/ (!h1IsStb))
+  if /**addOnlyOne &&*/ (/*(*/ !h1IsStb /*)*/) 
     temph1 = kStd(h1,currQuotient,hom,&weights,NULL);
   else
Index: kernel/syz0.cc
===================================================================
--- kernel/syz0.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ kernel/syz0.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -910,5 +910,5 @@
 //idPrint(res[syzIndex+1]);
 
-    if ((syzIndex==0))
+    if ( /*(*/ syzIndex==0 /*)*/ )
     {
       if ((hom==isHomog)|| (rHasGlobalOrdering(origR)))
Index: kernel/tgb_internal.h
===================================================================
--- kernel/tgb_internal.h	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ kernel/tgb_internal.h	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -1110,5 +1110,5 @@
    {
      MonRedResNP<number_type> red=mon[i];
-     if ((red.ref))
+     if ( /*(*/ red.ref /*)*/ )
      {
        if (red.ref->row)
@@ -1953,5 +1953,5 @@
   if (res_holder){
     succ=TRUE;
-    if ((res_holder->value_len==backLinkCode)){
+    if ( /*(*/ res_holder->value_len==backLinkCode /*)*/ ){
       len=1;
       return term;
Index: kernel/walkSupport.cc
===================================================================
--- kernel/walkSupport.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ kernel/walkSupport.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -1123,5 +1123,5 @@
       (*res)[j]=(int64)weights[j];
   }
-  else if( (r->order[0]==ringorder_a64) )
+  else if(  /*(*/ r->order[0]==ringorder_a64 /*)*/  )
   {
     int64* weights=(int64*)r->wvhdl[0];
Index: libpolys/coeffs/modulop.cc
===================================================================
--- libpolys/coeffs/modulop.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ libpolys/coeffs/modulop.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -539,5 +539,5 @@
                                % r->ch);
           r->npLogTable[r->npExpTable[i]] = i;
-          if (/*(i == r->ch - 1 ) ||*/ (r->npExpTable[i] == 1))
+          if /*(i == r->ch - 1 ) ||*/ (/*(*/ r->npExpTable[i] == 1 /*)*/) 
             break;
         }
Index: libpolys/polys/ext_fields/transext.cc
===================================================================
--- libpolys/polys/ext_fields/transext.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ libpolys/polys/ext_fields/transext.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -1514,5 +1514,5 @@
 void ntNormalize (number &a, const coeffs cf)
 {
-  if ((a!=NULL))
+  if ( /*(*/ a!=NULL /*)*/ )
   {
     definiteGcdCancellation(a, cf, FALSE);
Index: libpolys/polys/nc/sca.cc
===================================================================
--- libpolys/polys/nc/sca.cc	(revision b5f27dd8b00738efde14a72f129d4b6173d951f4)
+++ libpolys/polys/nc/sca.cc	(revision 805db880fb96d59fecac7fee422e4f6717e4b9cb)
@@ -477,5 +477,5 @@
 #endif
 
-  if( ( pPoly == NULL ) /*|| ( pMonom == NULL )*/ )
+  if (/*(*/  pPoly == NULL  /*)*/) /*|| ( pMonom == NULL )*/ 
     return NULL;
 