Index: factory/facAbsBiFact.cc
===================================================================
--- factory/facAbsBiFact.cc	(revision 44cd9a84967624b3cb752fb6646f1824acd60ae1)
+++ factory/facAbsBiFact.cc	(revision 849b7c0914e5ad7a169d24144d3e469708518d0b)
@@ -74,85 +74,4 @@
   }
   result.insert (CFAFactor (LcF, 1, 1));
-  return result;
-}
-
-
-/// absolute factorization of bivariate poly over Q
-///
-/// @return absFactorize returns a list whose entries contain three entities:
-///         an absolute irreducible factor, an irreducible univariate polynomial
-///         that defines the minimal field extension over which the irreducible
-///         factor is defined and the multiplicity of the absolute irreducible
-///         factor
-CFAFList absBiFactorize (const CanonicalForm& G ///<[in] bivariate poly over Q
-                        )
-{
-  //TODO handle homogeneous input
-  ASSERT (getNumVars (G) <= 2, "expected bivariate input");
-  ASSERT (getCharacteristic() == 0, "expected poly over Q");
-
-  CFMap N;
-  CanonicalForm F= compress (G, N);
-  bool isRat= isOn (SW_RATIONAL);
-  if (isRat)
-    F *= bCommonDen (F);
-
-  Off (SW_RATIONAL);
-  F /= icontent (F);
-  if (isRat)
-    On (SW_RATIONAL);
-
-  CanonicalForm contentX= content (F, 1);
-  CanonicalForm contentY= content (F, 2);
-  F /= (contentX*contentY);
-  CFAFList contentXFactors, contentYFactors;
-  contentXFactors= uniAbsFactorize (contentX);
-  contentYFactors= uniAbsFactorize (contentY);
-
-  if (contentXFactors.getFirst().factor().inCoeffDomain())
-    contentXFactors.removeFirst();
-  if (contentYFactors.getFirst().factor().inCoeffDomain())
-    contentYFactors.removeFirst();
-  if (F.inCoeffDomain())
-  {
-    CFAFList result;
-    for (CFAFListIterator i= contentXFactors; i.hasItem(); i++)
-      result.append (CFAFactor (N (i.getItem().factor()), i.getItem().minpoly(),
-                                i.getItem().exp()));
-    for (CFAFListIterator i= contentYFactors; i.hasItem(); i++)
-      result.append (CFAFactor (N (i.getItem().factor()),i.getItem().minpoly(),
-                                i.getItem().exp()));
-    normalize (result);
-    result.insert (CFAFactor (Lc (G), 1, 1));
-    return result;
-  }
-  CFFList rationalFactors= factorize (F);
-
-  CFAFList result, resultBuf;
-
-  CFAFListIterator iter;
-  CFFListIterator i= rationalFactors;
-  i++;
-  for (; i.hasItem(); i++)
-  {
-    resultBuf= absBiFactorizeMain (i.getItem().factor());
-    for (iter= resultBuf; iter.hasItem(); iter++)
-      iter.getItem()= CFAFactor (iter.getItem().factor(),
-                                 iter.getItem().minpoly(), i.getItem().exp());
-    result= Union (result, resultBuf);
-  }
-
-  for (CFAFListIterator i= result; i.hasItem(); i++)
-    i.getItem()= CFAFactor (N (i.getItem().factor()), i.getItem().minpoly(),
-                            i.getItem().exp());
-  for (CFAFListIterator i= contentXFactors; i.hasItem(); i++)
-    result.append (CFAFactor (N(i.getItem().factor()), i.getItem().minpoly(),
-                              i.getItem().exp()));
-  for (CFAFListIterator i= contentYFactors; i.hasItem(); i++)
-    result.append (CFAFactor (N(i.getItem().factor()), i.getItem().minpoly(),
-                              i.getItem().exp()));
-  normalize (result);
-  result.insert (CFAFactor (Lc(G), 1, 1));
-
   return result;
 }
Index: factory/facAbsBiFact.h
===================================================================
--- factory/facAbsBiFact.h	(revision 44cd9a84967624b3cb752fb6646f1824acd60ae1)
+++ factory/facAbsBiFact.h	(revision 849b7c0914e5ad7a169d24144d3e469708518d0b)
@@ -56,11 +56,3 @@
                          );
 
-/*BEGINPUBLIC*/
-
-#ifdef HAVE_NTL
-CFAFList absBiFactorize (const CanonicalForm& G);
 #endif
-
-/*ENDPUBLIC*/
-
-#endif
Index: factory/factory.template
===================================================================
--- factory/factory.template	(revision 44cd9a84967624b3cb752fb6646f1824acd60ae1)
+++ factory/factory.template	(revision 849b7c0914e5ad7a169d24144d3e469708518d0b)
@@ -107,7 +107,4 @@
 
 /*MAKEHEADER PUBLIC ONLY*/
-#include "facAbsBiFact.h"
-
-/*MAKEHEADER PUBLIC ONLY*/
 #include "facAbsFact.h"
 